/**
 * Copyright (c) 2010-2013, Zoltan Ujhelyi, Istvan Rath and Daniel Varro
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Zoltan Ujhelyi - initial API and implementation
 *   Csaba Debreceni - add exception for deprecated methods
 */
package org.eclipse.viatra.addon.viewers.runtime.notation;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Edge</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link org.eclipse.viatra.addon.viewers.runtime.notation.Edge#getSource <em>Source</em>}</li>
 *   <li>{@link org.eclipse.viatra.addon.viewers.runtime.notation.Edge#getTarget <em>Target</em>}</li>
 * </ul>
 *
 * @see org.eclipse.viatra.addon.viewers.runtime.notation.NotationPackage#getEdge()
 * @model
 * @generated
 */
public interface Edge extends FormattableElement {
	/**
	 * Returns the value of the '<em><b>Source</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Source</em>' reference.
	 * @see #setSource(Item)
	 * @see org.eclipse.viatra.addon.viewers.runtime.notation.NotationPackage#getEdge_Source()
	 * @model required="true"
	 * @generated
	 */
	Item getSource();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.addon.viewers.runtime.notation.Edge#getSource <em>Source</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Source</em>' reference.
	 * @see #getSource()
	 * @generated
	 */
	void setSource(Item value);

	/**
	 * Returns the value of the '<em><b>Target</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Target</em>' reference.
	 * @see #setTarget(Item)
	 * @see org.eclipse.viatra.addon.viewers.runtime.notation.NotationPackage#getEdge_Target()
	 * @model required="true"
	 * @generated
	 */
	Item getTarget();

	/**
	 * Sets the value of the '{@link org.eclipse.viatra.addon.viewers.runtime.notation.Edge#getTarget <em>Target</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Target</em>' reference.
	 * @see #getTarget()
	 * @generated
	 */
	void setTarget(Item value);

} // Edge
