/*******************************************************************************
 * Copyright (c) 2017, Abel Hegedus, IncQuery Labs Ltd.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *   Abel Hegedus - initial API and implementation
 *******************************************************************************/
package org.eclipse.viatra.query.tooling.core.preferences;

/**
 * Constant definitions for VIATRA Query Tooling Core plug-in preferences
 * 
 * @noreference This experimental class is not intended to be referenced by clients.
 */
public class ToolingCorePreferenceConstants {

    private ToolingCorePreferenceConstants() {/*Utility class constructor*/}
    
    /**
     * This preference stores the user's preference to disable automatic target platform metamodel index updates.
     * 
     * @see org.eclipse.viatra.query.tooling.core.targetplatform.TargetPlatformMetamodelsIndex
     * @noreference This experimental constant is not intended to be referenced by clients.
     */
    public static final String P_DISABLE_TARGET_PLATFORM_METAMODEL_INDEX_UPDATE = "org.eclipse.viatra.query.tooling.core.disableTargetPlatformIndex";

}
